diff -ruN vdr-1.7.12/channels.c vdr-1.7.13/channels.c
--- vdr-1.7.12/channels.c	2010-01-02 18:38:40.000000000 +0100
+++ vdr-1.7.13/channels.c	2010-02-21 14:36:04.000000000 +0100
@@ -4,11 +4,10 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.c 2.12 2010/01/02 17:38:40 kls Exp $
+ * $Id: channels.c 2.13 2010/02/21 13:36:04 kls Exp $
  */
 
 #include "channels.h"
-#include <linux/dvb/frontend.h>
 #include <ctype.h>
 #include "device.h"
 #include "epg.h"
@@ -18,133 +17,6 @@
 // format characters in order to allow any number of blanks after a numeric
 // value!
 
-// --- Channel Parameter Maps ------------------------------------------------
-
-const tChannelParameterMap InversionValues[] = {
-  {   0, INVERSION_OFF,  trNOOP("off") },
-  {   1, INVERSION_ON,   trNOOP("on") },
-  { 999, INVERSION_AUTO, trNOOP("auto") },
-  {  -1, 0, NULL }
-  };
-
-const tChannelParameterMap BandwidthValues[] = {
-  {   6, 6000000, "6 MHz" },
-  {   7, 7000000, "7 MHz" },
-  {   8, 8000000, "8 MHz" },
-  {  -1, 0, NULL }
-  };
-
-const tChannelParameterMap CoderateValues[] = {
-  {   0, FEC_NONE, trNOOP("none") },
-  {  12, FEC_1_2,  "1/2" },
-  {  23, FEC_2_3,  "2/3" },
-  {  34, FEC_3_4,  "3/4" },
-  {  35, FEC_3_5,  "3/5" },
-  {  45, FEC_4_5,  "4/5" },
-  {  56, FEC_5_6,  "5/6" },
-  {  67, FEC_6_7,  "6/7" },
-  {  78, FEC_7_8,  "7/8" },
-  {  89, FEC_8_9,  "8/9" },
-  { 910, FEC_9_10, "9/10" },
-  { 999, FEC_AUTO, trNOOP("auto") },
-  {  -1, 0, NULL }
-  };
-
-const tChannelParameterMap ModulationValues[] = {
-  {  16, QAM_16,   "QAM16" },
-  {  32, QAM_32,   "QAM32" },
-  {  64, QAM_64,   "QAM64" },
-  { 128, QAM_128,  "QAM128" },
-  { 256, QAM_256,  "QAM256" },
-  {   2, QPSK,     "QPSK" },
-  {   5, PSK_8,    "8PSK" },
-  {   6, APSK_16,  "16APSK" },
-  {  10, VSB_8,    "VSB8" },
-  {  11, VSB_16,   "VSB16" },
-  { 998, QAM_AUTO, "QAMAUTO" },
-  {  -1, 0, NULL }
-  };
-
-const tChannelParameterMap SystemValues[] = {
-  {   0, SYS_DVBS,  "DVB-S" },
-  {   1, SYS_DVBS2, "DVB-S2" },
-  {  -1, 0, NULL }
-  };
-
-const tChannelParameterMap TransmissionValues[] = {
-  {   2, TRANSMISSION_MODE_2K,   "2K" },
-  {   8, TRANSMISSION_MODE_8K,   "8K" },
-  { 999, TRANSMISSION_MODE_AUTO, trNOOP("auto") },
-  {  -1, 0, NULL }
-  };
-
-const tChannelParameterMap GuardValues[] = {
-  {   4, GUARD_INTERVAL_1_4,  "1/4" },
-  {   8, GUARD_INTERVAL_1_8,  "1/8" },
-  {  16, GUARD_INTERVAL_1_16, "1/16" },
-  {  32, GUARD_INTERVAL_1_32, "1/32" },
-  { 999, GUARD_INTERVAL_AUTO, trNOOP("auto") },
-  {  -1, 0, NULL }
-  };
-
-const tChannelParameterMap HierarchyValues[] = {
-  {   0, HIERARCHY_NONE, trNOOP("none") },
-  {   1, HIERARCHY_1,    "1" },
-  {   2, HIERARCHY_2,    "2" },
-  {   4, HIERARCHY_4,    "4" },
-  { 999, HIERARCHY_AUTO, trNOOP("auto") },
-  {  -1, 0, NULL }
-  };
-
-const tChannelParameterMap RollOffValues[] = {
-  {   0, ROLLOFF_AUTO, trNOOP("auto") },
-  {  20, ROLLOFF_20, "0.20" },
-  {  25, ROLLOFF_25, "0.25" },
-  {  35, ROLLOFF_35, "0.35" },
-  {  -1, 0, NULL }
-  };
-
-int UserIndex(int Value, const tChannelParameterMap *Map)
-{
-  const tChannelParameterMap *map = Map;
-  while (map && map->userValue != -1) {
-        if (map->userValue == Value)
-           return map - Map;
-        map++;
-        }
-  return -1;
-}
-
-int DriverIndex(int Value, const tChannelParameterMap *Map)
-{
-  const tChannelParameterMap *map = Map;
-  while (map && map->userValue != -1) {
-        if (map->driverValue == Value)
-           return map - Map;
-        map++;
-        }
-  return -1;
-}
-
-int MapToUser(int Value, const tChannelParameterMap *Map, const char **String)
-{
-  int n = DriverIndex(Value, Map);
-  if (n >= 0) {
-     if (String)
-        *String = tr(Map[n].userString);
-     return Map[n].userValue;
-     }
-  return -1;
-}
-
-int MapToDriver(int Value, const tChannelParameterMap *Map)
-{
-  int n = UserIndex(Value, Map);
-  if (n >= 0)
-     return Map[n].driverValue;
-  return -1;
-}
-
 // --- tChannelID ------------------------------------------------------------
 
 const tChannelID tChannelID::InvalidID;
@@ -189,16 +61,6 @@
   provider = strdup("");
   portalName = strdup("");
   memset(&__BeginData__, 0, (char *)&__EndData__ - (char *)&__BeginData__);
-  inversion    = INVERSION_AUTO;
-  bandwidth    = 8000000;
-  coderateH    = FEC_AUTO;
-  coderateL    = FEC_AUTO;
-  modulation   = QPSK;
-  system       = SYS_DVBS;
-  transmission = TRANSMISSION_MODE_AUTO;
-  guard        = GUARD_INTERVAL_AUTO;
-  hierarchy    = HIERARCHY_AUTO;
-  rollOff      = ROLLOFF_AUTO;
   modification = CHANNELMOD_NONE;
   schedule     = NULL;
   linkChannels = NULL;
@@ -248,17 +110,18 @@
   provider = strcpyrealloc(provider, Channel.provider);
   portalName = strcpyrealloc(portalName, Channel.portalName);
   memcpy(&__BeginData__, &Channel.__BeginData__, (char *)&Channel.__EndData__ - (char *)&Channel.__BeginData__);
+  parameters = Channel.parameters;
   return *this;
 }
 
 int cChannel::Transponder(int Frequency, char Polarization)
 {
   // some satellites have transponders at the same frequency, just with different polarization:
-  switch (tolower(Polarization)) {
-    case 'h': Frequency += 100000; break;
-    case 'v': Frequency += 200000; break;
-    case 'l': Frequency += 300000; break;
-    case 'r': Frequency += 400000; break;
+  switch (toupper(Polarization)) {
+    case 'H': Frequency += 100000; break;
+    case 'V': Frequency += 200000; break;
+    case 'L': Frequency += 300000; break;
+    case 'R': Frequency += 400000; break;
     default: esyslog("ERROR: invalid value for Polarization '%c'", Polarization);
     }
   return Frequency;
@@ -269,8 +132,11 @@
   int tf = frequency;
   while (tf > 20000)
         tf /= 1000;
-  if (IsSat())
-     tf = Transponder(tf, polarization);
+  if (IsSat()) {
+     const char *p = strpbrk(parameters, "HVLRhvlr"); // lowercase for backwards compatibility
+     if (p)
+        tf = Transponder(tf, *p);
+     }
   return tf;
 }
 
@@ -296,22 +162,16 @@
      frequency    = Channel->frequency;
      source       = Channel->source;
      srate        = Channel->srate;
-     polarization = Channel->polarization;
-     inversion    = Channel->inversion;
-     bandwidth    = Channel->bandwidth;
-     coderateH    = Channel->coderateH;
-     coderateL    = Channel->coderateL;
-     modulation   = Channel->modulation;
-     system       = Channel->system;
-     transmission = Channel->transmission;
-     guard        = Channel->guard;
-     hierarchy    = Channel->hierarchy;
-     rollOff      = Channel->rollOff;
+     parameters   = Channel->parameters;
      }
 }
 
-bool cChannel::SetSatTransponderData(int Source, int Frequency, char Polarization, int Srate, int CoderateH, int Modulation, int System, int RollOff)
+bool cChannel::SetTransponderData(int Source, int Frequency, int Srate, const char *Parameters, bool Quiet)
 {
+  if (strchr(Parameters, ':')) {
+     esyslog("ERROR: parameter string '%s' contains ':'", Parameters);
+     return false;
+     }
   // Workarounds for broadcaster stupidity:
   // Some providers broadcast the transponder frequency of their channels with two different
   // values (like 12551 and 12552), so we need to allow for a little tolerance here
@@ -324,60 +184,14 @@
   if (abs(srate - Srate) <= 1)
      Srate = srate;
 
-  if (source != Source || frequency != Frequency || polarization != Polarization || srate != Srate || coderateH != CoderateH || modulation != Modulation || system != System || rollOff != RollOff) {
+  if (source != Source || frequency != Frequency || srate != Srate || strcmp(parameters, Parameters)) {
      cString OldTransponderData = TransponderDataToString();
      source = Source;
      frequency = Frequency;
-     polarization = Polarization;
      srate = Srate;
-     coderateH = CoderateH;
-     modulation = Modulation;
-     system = System;
-     rollOff = RollOff;
+     parameters = Parameters;
      schedule = NULL;
-     if (Number()) {
-        dsyslog("changing transponder data of channel %d from %s to %s", Number(), *OldTransponderData, *TransponderDataToString());
-        modification |= CHANNELMOD_TRANSP;
-        Channels.SetModified();
-        }
-     }
-  return true;
-}
-
-bool cChannel::SetCableTransponderData(int Source, int Frequency, int Modulation, int Srate, int CoderateH)
-{
-  if (source != Source || frequency != Frequency || modulation != Modulation || srate != Srate || coderateH != CoderateH) {
-     cString OldTransponderData = TransponderDataToString();
-     source = Source;
-     frequency = Frequency;
-     modulation = Modulation;
-     srate = Srate;
-     coderateH = CoderateH;
-     schedule = NULL;
-     if (Number()) {
-        dsyslog("changing transponder data of channel %d from %s to %s", Number(), *OldTransponderData, *TransponderDataToString());
-        modification |= CHANNELMOD_TRANSP;
-        Channels.SetModified();
-        }
-     }
-  return true;
-}
-
-bool cChannel::SetTerrTransponderData(int Source, int Frequency, int Bandwidth, int Modulation, int Hierarchy, int CoderateH, int CoderateL, int Guard, int Transmission)
-{
-  if (source != Source || frequency != Frequency || bandwidth != Bandwidth || modulation != Modulation || hierarchy != Hierarchy || coderateH != CoderateH || coderateL != CoderateL || guard != Guard || transmission != Transmission) {
-     cString OldTransponderData = TransponderDataToString();
-     source = Source;
-     frequency = Frequency;
-     bandwidth = Bandwidth;
-     modulation = Modulation;
-     hierarchy = Hierarchy;
-     coderateH = CoderateH;
-     coderateL = CoderateL;
-     guard = Guard;
-     transmission = Transmission;
-     schedule = NULL;
-     if (Number()) {
+     if (Number() && !Quiet) {
         dsyslog("changing transponder data of channel %d from %s to %s", Number(), *OldTransponderData, *TransponderDataToString());
         modification |= CHANNELMOD_TRANSP;
         Channels.SetModified();
@@ -634,90 +448,11 @@
   refChannel = RefChannel;
 }
 
-static int PrintParameter(char *p, char Name, int Value)
-{
-  return Value >= 0 && Value != 999 ? sprintf(p, "%c%d", Name, Value) : 0;
-}
-
 cString cChannel::TransponderDataToString(void) const
 {
   if (cSource::IsTerr(source))
-     return cString::sprintf("%d:%s:%s", frequency, *ParametersToString(), *cSource::ToString(source));
-  return cString::sprintf("%d:%s:%s:%d", frequency, *ParametersToString(), *cSource::ToString(source), srate);
-}
-
-cString cChannel::ParametersToString(void) const
-{
-  char type = **cSource::ToString(source);
-  if (isdigit(type))
-     type = 'S';
-#define ST(s) if (strchr(s, type))
-  char buffer[64];
-  char *q = buffer;
-  *q = 0;
-  ST(" S ")  q += sprintf(q, "%c", polarization);
-  ST("  T")  q += PrintParameter(q, 'B', MapToUser(bandwidth, BandwidthValues));
-  ST("CST")  q += PrintParameter(q, 'C', MapToUser(coderateH, CoderateValues));
-  ST("  T")  q += PrintParameter(q, 'D', MapToUser(coderateL, CoderateValues));
-  ST("  T")  q += PrintParameter(q, 'G', MapToUser(guard, GuardValues));
-  ST("CST")  q += PrintParameter(q, 'I', MapToUser(inversion, InversionValues));
-  ST("CST")  q += PrintParameter(q, 'M', MapToUser(modulation, ModulationValues));
-  ST(" S ")  q += PrintParameter(q, 'O', MapToUser(rollOff, RollOffValues));
-  ST(" S ")  q += PrintParameter(q, 'S', MapToUser(system, SystemValues));
-  ST("  T")  q += PrintParameter(q, 'T', MapToUser(transmission, TransmissionValues));
-  ST("  T")  q += PrintParameter(q, 'Y', MapToUser(hierarchy, HierarchyValues));
-  return buffer;
-}
-
-static const char *ParseParameter(const char *s, int &Value, const tChannelParameterMap *Map)
-{
-  if (*++s) {
-     char *p = NULL;
-     errno = 0;
-     int n = strtol(s, &p, 10);
-     if (!errno && p != s) {
-        Value = MapToDriver(n, Map);
-        if (Value >= 0)
-           return p;
-        }
-     }
-  esyslog("ERROR: invalid value for parameter '%c'", *(s - 1));
-  return NULL;
-}
-
-static const char *SkipDigits(const char *s)
-{
-  while (*++s && isdigit(*s))
-        ;
-  return s;
-}
-
-bool cChannel::StringToParameters(const char *s)
-{
-  while (s && *s) {
-        switch (toupper(*s)) {
-          case 'A': s = SkipDigits(s); break; // for compatibility with the "multiproto" approach - may be removed in future versions
-          case 'B': s = ParseParameter(s, bandwidth, BandwidthValues); break;
-          case 'C': s = ParseParameter(s, coderateH, CoderateValues); break;
-          case 'D': s = ParseParameter(s, coderateL, CoderateValues); break;
-          case 'G': s = ParseParameter(s, guard, GuardValues); break;
-          case 'H': polarization = *s++; break;
-          case 'I': s = ParseParameter(s, inversion, InversionValues); break;
-          case 'L': polarization = *s++; break;
-          case 'M': s = ParseParameter(s, modulation, ModulationValues); break;
-          case 'O': s = ParseParameter(s, rollOff, RollOffValues); break;
-          case 'P': s = SkipDigits(s); break; // for compatibility with the "multiproto" approach - may be removed in future versions
-          case 'R': polarization = *s++; break;
-          case 'S': s = ParseParameter(s, system, SystemValues); break;
-          case 'T': s = ParseParameter(s, transmission, TransmissionValues); break;
-          case 'V': polarization = *s++; break;
-          case 'Y': s = ParseParameter(s, hierarchy, HierarchyValues); break;
-          case 'Z': s = SkipDigits(s); break; // for compatibility with the original DVB-S2 patch - may be removed in future versions
-          default: esyslog("ERROR: unknown parameter key '%c'", *s);
-                   return false;
-          }
-        }
-  return true;
+     return cString::sprintf("%d:%s:%s", frequency, *parameters, *cSource::ToString(source));
+  return cString::sprintf("%d:%s:%s:%d", frequency, *parameters, *cSource::ToString(source), srate);
 }
 
 cString cChannel::ToText(const cChannel *Channel)
@@ -762,7 +497,7 @@
      q = caidbuf;
      q += IntArrayToString(q, Channel->caids, 16);
      *q = 0;
-     buffer = cString::sprintf("%s:%d:%s:%s:%d:%s:%s:%d:%s:%d:%d:%d:%d\n", FullName, Channel->frequency, *Channel->ParametersToString(), *cSource::ToString(Channel->source), Channel->srate, vpidbuf, apidbuf, Channel->tpid, caidbuf, Channel->sid, Channel->nid, Channel->tid, Channel->rid);
+     buffer = cString::sprintf("%s:%d:%s:%s:%d:%s:%s:%d:%s:%d:%d:%d:%d\n", FullName, Channel->frequency, *Channel->parameters, *cSource::ToString(Channel->source), Channel->srate, vpidbuf, apidbuf, Channel->tpid, caidbuf, Channel->sid, Channel->nid, Channel->tid, Channel->rid);
      }
   return buffer;
 }
@@ -814,7 +549,8 @@
         dpids[0] = 0;
         ok = false;
         if (parambuf && sourcebuf && vpidbuf && apidbuf) {
-           ok = StringToParameters(parambuf) && (source = cSource::FromString(sourcebuf)) >= 0;
+           parameters = parambuf;
+           ok = (source = cSource::FromString(sourcebuf)) >= 0;
 
            char *p;
            if ((p = strchr(vpidbuf, '=')) != NULL) {
diff -ruN vdr-1.7.12/channels.h vdr-1.7.13/channels.h
--- vdr-1.7.12/channels.h	2009-12-06 13:57:45.000000000 +0100
+++ vdr-1.7.13/channels.h	2010-02-21 15:05:49.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.h 2.7 2009/12/06 12:57:45 kls Exp $
+ * $Id: channels.h 2.8 2010/02/21 14:05:49 kls Exp $
  */
 
 #ifndef __CHANNELS_H
@@ -47,27 +47,6 @@
 #define CA_ENCRYPTED_MIN 0x0100
 #define CA_ENCRYPTED_MAX 0xFFFF
 
-struct tChannelParameterMap {
-  int userValue;
-  int driverValue;
-  const char *userString;
-  };
-
-int MapToUser(int Value, const tChannelParameterMap *Map, const char **String = NULL);
-int MapToDriver(int Value, const tChannelParameterMap *Map);
-int UserIndex(int Value, const tChannelParameterMap *Map);
-int DriverIndex(int Value, const tChannelParameterMap *Map);
-
-extern const tChannelParameterMap InversionValues[];
-extern const tChannelParameterMap BandwidthValues[];
-extern const tChannelParameterMap CoderateValues[];
-extern const tChannelParameterMap ModulationValues[];
-extern const tChannelParameterMap SystemValues[];
-extern const tChannelParameterMap TransmissionValues[];
-extern const tChannelParameterMap GuardValues[];
-extern const tChannelParameterMap HierarchyValues[];
-extern const tChannelParameterMap RollOffValues[];
-
 struct tChannelID {
 private:
   int source;
@@ -110,6 +89,7 @@
 class cChannel : public cListObject {
   friend class cSchedules;
   friend class cMenuEditChannel;
+  friend class cDvbSourceParam;
 private:
   static cString ToText(const cChannel *Channel);
   char *name;
@@ -140,25 +120,13 @@
   int rid;
   int number;    // Sequence number assigned on load
   bool groupSep;
-  char polarization;
-  int inversion;
-  int bandwidth;
-  int coderateH;
-  int coderateL;
-  int modulation;
-  int system;
-  int transmission;
-  int guard;
-  int hierarchy;
-  int rollOff;
   int __EndData__;
+  cString parameters;
   int modification;
   mutable const cSchedule *schedule;
   cLinkChannels *linkChannels;
   cChannel *refChannel;
   cString TransponderDataToString(void) const;
-  cString ParametersToString(void) const;
-  bool StringToParameters(const char *s);
 public:
   cChannel(void);
   cChannel(const cChannel &Channel);
@@ -201,17 +169,7 @@
   int Number(void) const { return number; }
   void SetNumber(int Number) { number = Number; }
   bool GroupSep(void) const { return groupSep; }
-  char Polarization(void) const { return polarization; }
-  int Inversion(void) const { return inversion; }
-  int Bandwidth(void) const { return bandwidth; }
-  int CoderateH(void) const { return coderateH; }
-  int CoderateL(void) const { return coderateL; }
-  int Modulation(void) const { return modulation; }
-  int System(void) const { return system; }
-  int Transmission(void) const { return transmission; }
-  int Guard(void) const { return guard; }
-  int Hierarchy(void) const { return hierarchy; }
-  int RollOff(void) const { return rollOff; }
+  const char *Parameters(void) const { return parameters; }
   const cLinkChannels* LinkChannels(void) const { return linkChannels; }
   const cChannel *RefChannel(void) const { return refChannel; }
   bool IsCable(void) const { return cSource::IsCable(source); }
@@ -221,9 +179,7 @@
   bool HasTimer(void) const;
   int Modification(int Mask = CHANNELMOD_ALL);
   void CopyTransponderData(const cChannel *Channel);
-  bool SetSatTransponderData(int Source, int Frequency, char Polarization, int Srate, int CoderateH, int Modulation, int System, int RollOff);
-  bool SetCableTransponderData(int Source, int Frequency, int Modulation, int Srate, int CoderateH);
-  bool SetTerrTransponderData(int Source, int Frequency, int Bandwidth, int Modulation, int Hierarchy, int CodeRateH, int CodeRateL, int Guard, int Transmission);
+  bool SetTransponderData(int Source, int Frequency, int Srate, const char *Parameters, bool Quiet = false);
   void SetId(int Nid, int Tid, int Sid, int Rid = 0);
   void SetName(const char *Name, const char *ShortName, const char *Provider);
   void SetPortalName(const char *PortalName);
diff -ruN vdr-1.7.12/config.h vdr-1.7.13/config.h
--- vdr-1.7.12/config.h	2010-01-31 12:14:02.000000000 +0100
+++ vdr-1.7.13/config.h	2010-02-05 16:38:32.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.21 2010/01/31 11:14:02 kls Exp $
+ * $Id: config.h 2.22 2010/02/05 15:38:32 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.12"
-#define VDRVERSNUM   10712  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.13"
+#define VDRVERSNUM   10713  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.12"
-#define APIVERSNUM   10712  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.13"
+#define APIVERSNUM   10713  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
diff -ruN vdr-1.7.12/device.c vdr-1.7.13/device.c
--- vdr-1.7.12/device.c	2010-01-30 12:06:51.000000000 +0100
+++ vdr-1.7.13/device.c	2010-02-07 12:54:42.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.32 2010/01/30 11:06:51 kls Exp $
+ * $Id: device.c 2.35 2010/02/07 11:54:42 kls Exp $
  */
 
 #include "device.h"
@@ -44,6 +44,18 @@
   cDevice::PrimaryDevice()->PlayTs(Data, Length);
 }
 
+// --- cDeviceHook -----------------------------------------------------------
+
+cDeviceHook::cDeviceHook(void)
+{
+  cDevice::deviceHooks.Add(this);
+}
+
+bool cDeviceHook::DeviceProvidesTransponder(const cDevice *Device, const cChannel *Channel) const
+{
+  return true;
+}
+
 // --- cDevice ---------------------------------------------------------------
 
 // The default priority for non-primary devices:
@@ -59,6 +71,7 @@
 cDevice *cDevice::device[MAXDEVICES] = { NULL };
 cDevice *cDevice::primaryDevice = NULL;
 cDevice *cDevice::avoidDevice = NULL;
+cList<cDeviceHook> cDevice::deviceHooks;
 
 cDevice::cDevice(void)
 :patPmtParser(true)
@@ -570,6 +583,17 @@
   return false;
 }
 
+bool cDevice::DeviceHooksProvidesTransponder(const cChannel *Channel) const
+{
+  cDeviceHook *Hook = deviceHooks.First();
+  while (Hook) {
+        if (!Hook->DeviceProvidesTransponder(this, Channel))
+           return false;
+        Hook = deviceHooks.Next(Hook);
+        }
+  return true;
+}
+
 bool cDevice::ProvidesTransponder(const cChannel *Channel) const
 {
   return false;
@@ -594,6 +618,11 @@
   return 0;
 }
 
+const cChannel *cDevice::GetCurrentlyTunedTransponder(void) const
+{
+  return NULL;
+}
+
 bool cDevice::IsTunedToTransponder(const cChannel *Channel)
 {
   return false;
@@ -1024,11 +1053,15 @@
 void cDevice::Play(void)
 {
   Audios.MuteAudio(mute);
+  if (dvbSubtitleConverter)
+     dvbSubtitleConverter->Freeze(false);
 }
 
 void cDevice::Freeze(void)
 {
   Audios.MuteAudio(true);
+  if (dvbSubtitleConverter)
+     dvbSubtitleConverter->Freeze(true);
 }
 
 void cDevice::Mute(void)
diff -ruN vdr-1.7.12/device.h vdr-1.7.13/device.h
--- vdr-1.7.12/device.h	2010-01-01 16:04:27.000000000 +0100
+++ vdr-1.7.13/device.h	2010-02-06 15:34:41.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.19 2010/01/01 15:04:27 kls Exp $
+ * $Id: device.h 2.21 2010/02/06 14:34:41 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -88,10 +88,18 @@
 class cReceiver;
 class cLiveSubtitle;
 
+class cDeviceHook : public cListObject {
+public:
+  cDeviceHook(void);
+  virtual bool DeviceProvidesTransponder(const cDevice *Device, const cChannel *Channel) const;
+          ///< Returns true if the given Device can provide the given Channel's transponder.
+  };
+
 /// The cDevice class is the base from which actual devices can be derived.
 
 class cDevice : public cThread {
   friend class cLiveSubtitle;
+  friend class cDeviceHook;
 private:
   static int numDevices;
   static int useDevice;
@@ -187,6 +195,13 @@
   virtual bool HasDecoder(void) const;
          ///< Tells whether this device has an MPEG decoder.
 
+// Device hooks
+
+private:
+  static cList<cDeviceHook> deviceHooks;
+protected:
+  bool DeviceHooksProvidesTransponder(const cChannel *Channel) const;
+
 // SPU facilities
 
 private:
@@ -232,6 +247,11 @@
          ///< actually provide channels must implement this function.
          ///< The result of this function is used when selecting a device, in order
          ///< to avoid devices that provide more than one system.
+  virtual const cChannel *GetCurrentlyTunedTransponder(void) const;
+         ///< Returns a pointer to the currently tuned transponder.
+         ///< This is not one of the channels in the global cChannels list, but rather
+         ///< a local copy. The result may be NULL if the device is not tuned to any
+         ///< transponder.
   virtual bool IsTunedToTransponder(const cChannel *Channel);
          ///< Returns true if this device is currently tuned to the given Channel's
          ///< transponder.
diff -ruN vdr-1.7.12/diseqc.c vdr-1.7.13/diseqc.c
--- vdr-1.7.12/diseqc.c	2009-12-05 16:57:02.000000000 +0100
+++ vdr-1.7.13/diseqc.c	2010-02-06 16:43:31.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: diseqc.c 2.1 2009/12/05 15:57:02 kls Exp $
+ * $Id: diseqc.c 2.2 2010/02/06 15:43:31 kls Exp $
  */
 
 #include "diseqc.h"
@@ -16,6 +16,11 @@
 
 cDiseqc::cDiseqc(void)
 {
+  devices = 0;
+  source = 0;
+  slof = 0;
+  polarization = 0;
+  lof = 0;
   commands = NULL;
   parsing = false;
   numCodes = 0;
@@ -30,6 +35,21 @@
 {
   bool result = false;
   char *sourcebuf = NULL;
+  if (*s && s[strlen(s) - 1] == ':') {
+     const char *p = s;
+     while (*p && *p != ':') {
+           char *t = NULL;
+           int d = strtol(p, &t, 10);
+           p = t;
+           if (0 < d && d < 32)
+              devices |= (1 << d - 1);
+           else {
+              esyslog("ERROR: invalid device number %d in '%s'", d, s);
+              return false;
+              }
+           }
+     return true;
+     }
   int fields = sscanf(s, "%a[^ ] %d %c %d %a[^\n]", &sourcebuf, &slof, &polarization, &lof, &commands);
   if (fields == 4)
      commands = NULL; //XXX Apparently sscanf() doesn't work correctly if the last %a argument results in an empty string
@@ -126,9 +146,16 @@
 
 cDiseqcs Diseqcs;
 
-cDiseqc *cDiseqcs::Get(int Source, int Frequency, char Polarization)
+cDiseqc *cDiseqcs::Get(int Device, int Source, int Frequency, char Polarization)
 {
+  int Devices = 0;
   for (cDiseqc *p = First(); p; p = Next(p)) {
+      if (p->Devices()) {
+         Devices = p->Devices();
+         continue;
+         }
+      if (Devices && !(Devices & (1 << Device - 1)))
+         continue;
       if (p->Source() == Source && p->Slof() > Frequency && p->Polarization() == toupper(Polarization))
         return p;
       }
diff -ruN vdr-1.7.12/diseqc.conf vdr-1.7.13/diseqc.conf
--- vdr-1.7.12/diseqc.conf	2006-03-31 16:05:52.000000000 +0200
+++ vdr-1.7.13/diseqc.conf	2010-02-06 16:54:04.000000000 +0100
@@ -23,6 +23,10 @@
 #
 # The 'command...' part is optional.
 #
+# A line containing space separated integer numbers, terminated with a ':',
+# defines that any following DiSEqC sequences apply only to the given list
+# of device numbers.
+#
 # Examples:
 
 # Full DiSEqC sequence:
diff -ruN vdr-1.7.12/diseqc.h vdr-1.7.13/diseqc.h
--- vdr-1.7.12/diseqc.h	2002-12-07 14:54:02.000000000 +0100
+++ vdr-1.7.13/diseqc.h	2010-02-06 16:14:42.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: diseqc.h 2.0 2002/12/07 13:54:02 kls Exp $
+ * $Id: diseqc.h 2.1 2010/02/06 15:14:42 kls Exp $
  */
 
 #ifndef __DISEQC_H
@@ -26,6 +26,7 @@
     };
   enum { MaxDiseqcCodes = 6 };
 private:
+  int devices;
   int source;
   int slof;
   char polarization;
@@ -48,6 +49,7 @@
       // it. Call Execute() repeatedly (always providing the same CurrentAction pointer)
       // until it returns daNone. After a successful execution of all commands
       // *CurrentAction points to the value 0x00.
+  int Devices(void) const { return devices; }
   int Source(void) const { return source; }
   int Slof(void) const { return slof; }
   char Polarization(void) const { return polarization; }
@@ -58,7 +60,7 @@
 
 class cDiseqcs : public cConfig<cDiseqc> {
 public:
-  cDiseqc *Get(int Source, int Frequency, char Polarization);
+  cDiseqc *Get(int Device, int Source, int Frequency, char Polarization);
   };
 
 extern cDiseqcs Diseqcs;
